source("support_functions/zzz.R") # source("https://earth.bsc.es/gitlab/es/csindicators/-/raw/develop-SPEI/R/zzz.R")
source("support_functions/PeriodPET.R") # source("https://earth.bsc.es/gitlab/es/csindicators/-/raw/develop-SPEI/R/PeriodPET.R")
source("support_functions/PeriodSPEI.R") # source("https://earth.bsc.es/gitlab/es/csindicators/-/raw/develop-SPEI/R/PeriodSPEI.R")

save_SPEI_era5land <- function(region, accum,
                               calculate_spi, calculate_spei,
                               ref_period) {
  # SPI ----
  
  # load data
  data_prlr   <- readRDS(paste0("data/", region, "_prlr.rds"))
  data_tasmax <- readRDS(paste0("data/", region, "_tasmax.rds"))
  data_tasmin <- readRDS(paste0("data/", region, "_tasmin.rds"))
  
  
  for (i in accum) {
    print(paste0("Calculating accum ", i))
    if (calculate_spi) {
      spi <- CST_PeriodSPEI(exp = list(pr = data_prlr),
                            pet_exp = array(0, dim = dim(data_prlr$data)),
                            accum = i,
                            standardization = TRUE,
                            ref_period = ref_period,
                            handle_infinity = TRUE)
      # save as RDS
      saveRDS(spi, paste0("data/", region, "_spi_", i, ".rds"))
    }
    if (calculate_spei) {
      spei <- CST_PeriodSPEI(exp = list(tmax = data_tasmax,
                                        tmin = data_tasmin,
                                        pr = data_prlr),
                             accum = i,
                             standardization = TRUE,
                             ref_period = ref_period,
                             handle_infinity = TRUE)
      # save as rds
      saveRDS(spei, paste0("data/", region, "_spei_", i, ".rds"))
    }
  }
}